#include "math.h"
#pragma hdrstop

#include <vector>
 
#ifdef _RW_STD_IOSTREAM
#include <iostream>
#else
#include <iostream.h>
#endif     

#ifndef _RWSTD_NO_NAMESPACE
using namespace std;
#endif


#include "phi.h"

#define MAXPOP 30000
#define MAX_LONG_RAND 1073741823L

#define round(x) ((long) (x + (x >= 0.0 ?  0.5 : -0.5)))


    char *strupper(char *s)
    {
       char *p;
       p=s;
       while(*s)
       {
             if (*s >='a' && *s <= 'z')
                  *s=*s-'a'+'A';
            s++;
       }   
       return  p;
    }



    long long_rand()
    {
         return ((((long) rand())%32768L)+(((long)rand())%32768L)*32768L);
    }


   int sorteio(vector<long> pesos)
    { 
       if (pesos.size()  == 0) 
          return -1;   //  excesso 

       unsigned i;

       long soma=0;
       for (i=0;i<(unsigned)pesos.size();i++)
          soma += pesos[i];
        
        if (soma > MAX_LONG_RAND || soma ==0) 
        { 
           cout << "Fatal error.";   
           return -1; 
        }  

        long rd = long_rand()%(soma);                     

        soma=0;
        for (i=0;i<(unsigned)pesos.size();i++)
        {
          soma = soma + pesos[i];
          if (rd <= soma)
          { 
             return i;           
          } 
       
         }  
        cout <<"erro fatal"; 
        return -1;    // excesso...      
    }

 int iguais_indiv(individuo a, individuo b) // check if 2 individuals are the same
  {
    unsigned  i,iguais=1;
    for (i=0;i<(unsigned)a.vsize;i++)
      if (a.atributos[i] != b.atributos[i])
          {
          iguais=0;
          break;  
          }     
    return iguais;   
  } 

   double entropia(double p,double n)    // entropy calculations
   {

     if (n<=0 || p<=0)
        return 0;
     else
     {
        return  ((-p/(n+p))*log((double) p/(n+p))/log((double)2)  - (n/(n+p))*log((double) n/(n+p))/log((double)2));
     }
   }

    int proporcao::gera_amostra()
    {
     
      if  (valor == 0)
          return 0;
      if (valor == 1) 
          return 1;   
    
      if ( (double) (rand()%(PREC+1)) > round(valor*PREC))
          return 0;
       else 
          return 1;             
    }

    proporcao::proporcao()
    {
       valor = -1;
    }
    
    proporcao::proporcao(double v)
    {
       valor = v;   
    } 


   void mostra_bits(individuo IND) // show an individual
   {

     unsigned i;
     for (i=0;i<(unsigned)IND.vsize;i++) 
     {  
       printf("%d",IND.atributos[i]);

     } 
   }
 
    
   individuo::individuo(vector<proporcao> R)
   {
       vsize=R.size();
       int h;


       atributos= new (nothrow) int[R.size()];      

       for (unsigned i=0;i<(unsigned)R.size();i++)
          atributos[i] = R[i].gera_amostra();

       icluster = -1;        // cluster not defined yet   
   } 

  individuo::individuo()
   {
  
       atributos=0;
       icluster = -1;        // cluster not defined yet

   }

   individuo::~individuo()
   {

   }

   double cluster::distancia(int *I)          // distance form an individual to a cluster
   {
      double soma=0;  
      
      for (unsigned i=0;i<(unsigned)centroide.size();i++)
      {      
         double dif =I[i] - centroide[i].valor;
         dif=dif>0?dif:-dif;  
         soma = soma + dif;  // /PREC;
      }
      return soma;

   }

   cluster::cluster(int p,double alfa)     
   {
      valor_alfa = alfa;
      centroide.clear(); 
      proporcao *pr;

      for(unsigned i=0;i<(unsigned)p;i++)
      { 
         pr=new proporcao();
         centroide.push_back(*pr);
         delete pr;
      }  


   }

   cluster::cluster(vector<proporcao> R, double alfa)     
   {
      valor_alfa = alfa;
    
      centroide = R;  
   }

   void cluster::inclui (int *I)        // add an instance
   {
     double v;
  

        for (unsigned i=0; i<(unsigned)centroide.size();i++)
        {  

          if(num_indiv == 0)
          {  

             centroide_novo[i].valor = (double) I[i];          
          }
          else
          {
            double proporcao; 
            proporcao=((double) 1)/(num_indiv+1); // weight of the new instance
 
            v= proporcao*I[i] + (1-proporcao)*centroide_novo[i].valor;
            v=v>1?1:v;
            v=v<0?0:v;
            centroide_novo[i].valor =v;     
          } 
        }
        num_indiv ++; // account for another instance
        
   }
       

   int kmeans::inclui(int *I)            // add an instance
   {

      unsigned numcluster = mais_proximo(I);   // choose the nearest centroid

       clusters[numcluster].inclui(I);       // add
       return (int) numcluster;                           
   }



   int kmeans::mais_proximo(int *I)  // finds the nearest centroid
   {

      
      unsigned i,min_i;
      double min_dist,dist;

        
      min_i = 0;
      min_dist =  clusters[0].distancia(I);
      for (i=1;i<(unsigned)k;i++)       // calculate the distances        
      { 
         dist= clusters[i].distancia(I);
         if (dist< min_dist  || (dist==min_dist && rand()%2 ==0))
         {
            min_i=i;
            min_dist=dist; 
         } 
      }

      // select the nearest


     return min_i;
 
   }

   void kmeans::inicializa(populacao *pop, unsigned *atribuicoes,unsigned reseta)   // k-means initialization from a set of instances
   {
           
//       vector<unsigned> atribuicoes;      

       if (pop->size() < k)
          return;   // should raise an exception: too few instances

       unsigned i,j,indice;

       // randomly choose k instances as initial centroids IF a restart was required!
       if(reseta)  
        for (i=0;i<(unsigned)k;i++)
        {  indice=rand()%pop->size();   

            // set as centroid
            for (j=0;j< (unsigned) ((*pop)[indice]).vsize;j++)      
                clusters[i].centroide[j].valor = ((*pop)[indice].atributos[j]);
            clusters[i].centroide_novo = clusters[i].centroide; 
            clusters[i].num_indiv = 0;   
       } 
       
      unsigned num_cluster;
       for (i=0;i< (unsigned)pop->size(); i++)
       {
         num_cluster = inclui((*pop)[i].atributos);   // learn all instances
         atribuicoes[i]=num_cluster;
       }

       for (i=0;i<(unsigned)k;i++)             
       {
          clusters[i].centroide = clusters[i].centroide_novo; 
          clusters[i].num_indiv=0; 
       } 
   }                   
       
   

   kmeans::kmeans(unsigned vk, unsigned p, double alfa)
   { 
       k=vk; 

       cluster * pt; 
       for (unsigned i=0;i<(unsigned)k;i++)
       {  
          pt=new cluster(p,alfa);
          clusters.push_back(*pt);
          delete pt; 
       }
   }

   kmeans::~kmeans()
   {        
   }

 
   iGA::iGA(unsigned vseed) // constructor for phi-PBIL
   {
     if (vseed==0)
         seed= (unsigned)time(0);
     else
         seed = vseed;  
       
     srand(seed); 

      FILE * input=fopen("param.phi","rt");

      if (input==0)
      {
          cout << "Fatal error: file param.phi not found.";
         return;
      }
      char nome[80];
      char linha[100];
      long valor;
      int N0;

      wilson=50;
      Pold=50;
      Pcross=50;

      N=0;
      N0=0;
      p=0;
      k=0;

      while(!feof(input))   // learn parameters from file "param.phi" 
      {  
          char *pt;
          fgets(linha,99,input);
          pt=linha;
          while (*pt) { if (*pt == '=') *pt=' '; pt++;}
          sscanf(linha,"%s %u",nome,&valor);
          strcpy(nome,strupper(nome));
          if (!feof(input)) 
          {
             if (strcmp(nome,"SIZE")==0)
                p=valor;
             else if (strcmp(nome,"K")==0)
                k=valor;
             else if (strcmp(nome,"N0")==0)
                N0=valor;
             else if (strcmp(nome,"NW")==0)
                N=valor;
             else if (strcmp(nome,"PW")==0)
                wilson=valor;
             else if (strcmp(nome,"POLD")==0)
                Pold=valor;
             else if (strcmp(nome,"PC")==0)
                Pcross=valor;          
             else
             {
                printf("Fatal error: parameter name %c unknown in file param.phi.\n");
                exit(0);
             }
          }
      }      

      if (N0%N != 0) 
      {
         cout << "Fatal error: N0 is not a multiple of Nw.";
         exit(0); 
      }

      if (N<=0 || N0<=0 || p<=0 || k<=0) 
      {
         cout << "Fatal error: parameters N0, Nw, size and k must be specified and greater than 0.";
         return; 
      }

      extr=((double)N0)/N;   

      grupos = new kmeans(k, p, (double) 1/(((double) N)/k));  // (N/k) is the expected number of individuals per cluster, so alfa=1/(N/k);
      for (unsigned i=0;i<(unsigned)k;i++)
      {
         cont_cluster.push_back(0);
         mean_fitness.push_back(0);       
      }
   }


   individuo iGA::gera_individuo()
   {
      vector<proporcao> R;

     unsigned i;

      num_cluster = sorteio(mean_fitness);  // selects randomly a parent cluster
      unsigned num_bb;

      if ((unsigned) rand()%100 < Pcross) // to cross or not to cross??
      {
        num_bb = rand()%(k-1); // select another parent
        if (num_bb >= num_cluster)
           num_bb++;         //  must be different from the first parent..
     }
     else
         num_bb=num_cluster;                       
       

       proporcao P; 
       for (i=0; i<(unsigned)p;i++) 
        
            R.push_back(P);

        for (i=0; i<(unsigned)p;i++) 
        { 
             R[i].valor = (grupos->clusters[num_cluster].centroide[i].valor);
        }

       kind_cross= -1; 
       if (num_bb != num_cluster)  // will I cross??
       {

           kind_cross = ((unsigned) (rand()%100)<Pold);   // 1 for old hypothesis, 0 for new
           if ((unsigned) kind_cross == (unsigned) 0) // new
           {
             for (i=0; i<(unsigned)p;i++) 
               
              if (DH[num_bb][i]>DH[num_cluster][i])     
              {
                 R[i].valor = grupos->clusters[num_bb].centroide[i].valor;

              }   
            }                        
            else    // old              
             for (i=0; i<(unsigned)p;i++) 
              if (DH_ant[num_bb][i]>DH_ant[num_cluster][i])     
              {
                 R[i].valor = clusters_ant[num_bb].centroide[i].valor;

              }                                                 
       }

    if ((unsigned) rand()%100 < wilson)  // wilson point estimator for proportions

     for (i=0; i<(unsigned)p;i++)  
       { 

          double PP= R[i].valor*(N/k);            
          R[i].valor = ((PP+2)/((N/k)+4) );   
 
       }

       individuo I(R);   // breed

       return I;
   }


  void iGA::calcula_DH()    // calculate W, the difference in entropy
  {
       unsigned i,j;

       for (i=0;i<(unsigned)k;i++)
       { 
          cont_cluster[i]=0;
          mean_fitness[i]=0;
       }
       for (i=0;i<(unsigned)pop_geral.size();i++)
       {
          cont_cluster[posbons[i]]++;  
          mean_fitness[posbons[i]]+=(long) pop_geral[i].fitness;
       }

       
       for (i=0;i<k;i++)
       {          
          if (cont_cluster[i]!=0)
            mean_fitness[i]=(long) round((10*mean_fitness[i])/cont_cluster[i]);
       }

       vector<double> uns,zeros;   // ones and zeros in each gene

       for (j=0;j<p;j++)
       {
          uns.push_back(0);
          zeros.push_back(0); 
       }

       for (j=0;j<p;j++)
       {
          for (i=0;i<(unsigned)k;i++)
          {

            uns[j]+=  (grupos->clusters[i].centroide[j].valor);
            zeros[j]+= (1 - grupos->clusters[i].centroide[j].valor);                               
          } 
       } 
          
            

       for (i=0;i<(unsigned)k;i++)
         for(j=0;j<p;j++)
            DH[i][j] =  entropia(uns[j]*(N/k),zeros[j]*(N/k)) 
                       - entropia((uns[j] -  grupos->clusters[i].centroide[j].valor)*(N/k),

                          (zeros[j] - (1 - grupos->clusters[i].centroide[j].valor))* (N/k) );

  }

   void iGA::inicializa()   // starting phi-PBIL
   {

       unsigned i,j,tam;
      

       cont_novo_mau = 0;

       // generate a random population
       tam = (unsigned) round(N*extr); 
       individuo pop[MAXPOP];
       if (tam>MAXPOP) 
       {
         cout << "Fatal error: Max. pop size = "<<MAXPOP<<endl;
         return;
       }
       for (i=0;i<tam;i++)
       {
         pop[i].vsize=p; 
         pop[i].atributos= new (nothrow) int[p];      
         for (j=0;j<p;j++)
           pop[i].atributos[j]=rand()%2; 
         pop[i].fitness = (*fitness_function)(pop[i].atributos,p);
       }

        // fitness-ordered

       unsigned imenor;
       individuo aux;
       for (i=0;i<tam;i++)
       {
         imenor = i;
         for (j=i;j<(unsigned)N*extr;j++)
           if (pop[j].fitness < pop[imenor].fitness)
             imenor = j;
         aux=pop[i];

         pop[i]=pop[imenor];
         pop[imenor]= aux;

       }      

       // take the better

       pop_geral.clear();
       for (i=(unsigned) round(N*(extr-1));i<(unsigned) round(N*extr);i++)
       {
          pop_geral.push_back(pop[i]);
       }  


       for (i=0; i<(unsigned)pop_geral.size(); i++)
       {
          int *aux;
          aux=pop_geral[i].atributos;
          pop_geral[i].atributos =  new (nothrow) int[p];     
          for (j=0;j<p;j++)
             pop_geral[i].atributos[j]=aux[j]; 
       }  
        

       // learn k clusters (and the P matrix), and obtain the settings in posbons


       posbons= new (nothrow) unsigned[pop_geral.size()];    
  
       grupos->inicializa(&pop_geral,posbons,1);

       vector<double> v;
       for (i=0;i<p;i++) 
          v.push_back(0);

       for (i=0;i<(unsigned)k;i++) 
          DH.push_back(v);    
         
       calcula_DH();   // calculate W
      
       clusters_ant = grupos->clusters;
       cont_cluster_ant = cont_cluster;
       DH_ant = DH;
       performance_novos = 0;
       performance_antigos = 0; 
   }
 
   void iGA::itera()
   {
   
       unsigned i,j;

      //  breed
      individuo II;
      II=gera_individuo();   
      II.fitness =(*fitness_function)(II.atributos,p);

      if (II.fitness < pop_geral[0].fitness)   // bad??
      {
          cont_novo_mau++;   
          return;  
      }

      if (kind_cross==0 )  // good, from new clustering hypothesis?
          performance_novos++; 
     
      if (kind_cross==1 )  // good, from old clustering hypothesis?
          performance_antigos++;

      if (performance_novos > performance_antigos)    // are new clustering hypothesis doing better than old ones??
      {
       // the new is old now....  
       performance_antigos = performance_novos;  
       performance_novos=0;
       clusters_ant = grupos->clusters;
       cont_cluster_ant = cont_cluster;
       DH_ant = DH;    

      }   
      pop_geral.insere_ordenado(II);    // insert the new good  individual in the population

       unsigned tem_zero=0;

       for (i=0;i<(unsigned)k;i++)
           if (cont_cluster[i]==0) 
               tem_zero=1;             // is there some empty cluster??

       // remove the worst individual

       if (pop_geral.size()>0) 
         pop_geral.erase(pop_geral.begin());      

       // update clusters and P (restart kmeans only if a cluster is empty)
       grupos->inicializa(&pop_geral, posbons,tem_zero==1);   
//   cout << posbons[0]<<" "<<tem_zero<<endl;
          
       calcula_DH();   // compute W
  }
 

   void iGA::run(double (*fitness)(int *, int))    // let's go!!
   {

      fitness_function = fitness; 
      unsigned long MAX_EVAL = 500000;  //  limit for the number of fitness evaluations (arbitrary)
      inicializa();  

      cont_eval= (unsigned) round(N*extr); // account for the initialization...

      double ant_max=0; 
      parar=0;
      printf("max_fitness ; fit_eval\n");  


      while (!parar && cont_eval<=MAX_EVAL)
      {

        itera();     // do an incremental learning step
        cont_eval++;   // account for another fitness evaluation

       // check if centroids saturate
        unsigned flag_satur=1;
        for (unsigned i=0;i<(unsigned)k;i++)
        {
           if (cont_cluster[i]>0)
             for (unsigned j=0;j<p;j++)
               if (grupos->clusters[i].centroide[j].valor<0.95 && grupos->clusters[i].centroide[j].valor>0.05)            
               { 
                 flag_satur=0;
                 break;  
               }          

           if (!flag_satur) break;
        }

        if (flag_satur)    // stop when controids saturate
           parar=1; 
    

        if (ant_max != pop_geral[pop_geral.size()-1].fitness)   // report max fitness changes...
        {       
           ant_max = pop_geral[pop_geral.size()-1].fitness;      
           printf("%u ; %u\n",(long) pop_geral[pop_geral.size()-1].fitness,(long) cont_eval);

        } 
   
      }

     // ok, done
     // preparing the answer... :

     populacao resposta;
     double maior;
     vector<long> conts;
    
     unsigned i,j;
      for (j=0;j<(unsigned)pop_geral.size();j++)
      {

       int pos=-1;


        for (i=0;i<(unsigned)resposta.size();i++)
          if (iguais_indiv(pop_geral[j],resposta[i]))
          { 
            pos = i;
            break;
          } 
        if (pos==-1)
        {
           if (resposta.size() == 0)
               maior = pop_geral[j].fitness;
           resposta.push_back(pop_geral[j]);
          
           conts.push_back(1);
           if (pop_geral[j].fitness > maior)
              maior = pop_geral[j].fitness;
        }
        else
          conts[pos]++;
      }


       for (i=0; i<(unsigned)resposta.size(); i++)
       {
          int *aux;
          aux=resposta[i].atributos;
          resposta[i].atributos = new (nothrow) int[p];     
          for (j=0;j<p;j++)
             resposta[i].atributos[j]=aux[j];              
       }  
        

     // show final reports.
     unsigned contt=0;
     printf("\n\nfitness(int) ; count ; solution\n");
     for(i=0;i<(unsigned)resposta.size();i++)
     if (resposta[i].fitness == maior)
     {
       printf("%d ; %d ;",(int) resposta[i].fitness,(int) conts[i]); 
       mostra_bits(resposta[i]);
       printf("\n"); 
       contt++;
     }

     printf("\n\nfit_eval ; global_opt ; fitness (int) ; seed\n");
     printf("%d ; %d ; %d ; %u\n\n",cont_eval, contt,(int) maior,seed);
   } 

  
   void populacao::insere_ordenado(individuo IND)    // insert in the population, in an ordered fashion
   {

     unsigned pos=rand()%this->size();
     unsigned i;


     if (this->size() == 0)
        this->push_back(IND);
     else
     if (((*this)[pos].fitness==IND.fitness))
     {
        this->insert(this->begin()+pos,IND);         
     }
     else 
     { 

       for (i=0;i<(unsigned)this->size();i++)
          if (((*this)[i].fitness>IND.fitness) ||  ((*this)[i].fitness==IND.fitness && rand()%2==0)) 
             break;

       if (i<this->size())
          this->insert(this->begin()+i,IND);
       else
          this->push_back(IND); 
     }  
   }

   populacao::~populacao()
   {
       unsigned i;

       for (i=0; i< (unsigned)this->size();i++)
       if ((*this)[i].atributos != 0)
       {
        
         delete [] (*this)[i].atributos;
         (*this)[i].atributos = 0;
       }

   }

   void mostra_pop(populacao pop, double valor)   // show population
   {
     unsigned i;
     for(i=0;i<(unsigned)pop.size();i++)
     if (pop[i].fitness==valor)
     {
       mostra_bits(pop[i]);
        cout << endl; 
     }
     cout <<endl;
   }

