#include "math.h"
#pragma hdrstop

#include <vector>
#ifdef _RW_STD_IOSTREAM
#include <iostream>
#else
#include <iostream.h>
#endif     

#ifndef _RWSTD_NO_NAMESPACE
using namespace std;
#endif

#define PREC RAND_MAX


   class proporcao
   {
   
       public:
       double valor;
   
      
       double getvalor(); 
       void setvalor(double v); 
       int gera_amostra();
       proporcao(double v);
       proporcao();
   };


   class individuo
   {
      public:
      int * atributos;      
      int vsize;
      double fitness;
      int icluster;
      individuo();   
      individuo (vector<proporcao> R);       
      ~individuo();
   };


   class cluster
   {
       public:
       vector<proporcao>  centroide;
       vector<proporcao>  centroide_novo;
       double valor_alfa;
       long num_indiv;  

       double distancia(int *I);
       void inclui(int *I);
       cluster(int p, double alfa);                  
       cluster(vector<proporcao> R, double alfa);
                                       
   };


   class populacao : public vector<individuo>
   {
      public: 
      void insere_ordenado(individuo IND);
      ~populacao();
    };


   class kmeans
   {
       public:
       unsigned k;  
       vector<cluster> clusters;
        
       int inclui(int *I);   
       int mais_proximo(int *I);
       int mais_proximo(int *I, int exceto);
       void inicializa(populacao *pop, unsigned *atribuicoes,unsigned reseta);   // k-means initialization from a set of instances
       kmeans(unsigned vk, unsigned p, double alfa);
       ~kmeans();
   };


   class iGA
   {
      public:

      vector<int> dominante;
      vector<long> cont_cluster;
      vector< vector<double> > DH;
      populacao pop_geral;
      unsigned num_cluster;
      unsigned cont_novo_mau,cont_eval;
      unsigned seed;  
      int kind_cross;  
      unsigned parar,k,p,N,Pcross,Pold,wilson;
      long max; 
      long performance_novos,performance_antigos;
      unsigned *posbons;
      kmeans *grupos;
      vector<cluster> clusters_ant;
      vector<long> mean_fitness;
      vector<long> cont_cluster_ant;
      vector< vector<double> > DH_ant;
      double extr;        
      double (*fitness_function)(int *, int);       


      iGA(unsigned vseed);
      individuo gera_individuo();
      void calcula_DH(); 
      void grava_pop(populacao *pop, FILE *arq, int last);
      void inicializa();
      void itera();
      void run(double (*fitness)(int *, int));                                         
   };

